/* SF Lite Solar Wind r070822 */

/* Global variables */
var SFStart = new Date(), SFIsTiger = navigator.appVersion.indexOf('AppleWebKit/312') < 0;
var SFAbbreviated = /\/\D+$/.test(location.pathname), SFR = 'sevenfour://skin/SFR/', SFNextRes = 0;
var SFForwardRes, SFThreadURI, SFThreadHasID, SFSelection, SFISCache, SFSSImgs;
var SFMessageClear, SFRemoveBezel, SFScrolling;

/* Essential */
var sevenfour = {
    appendNewRes : function(new_res) {
        SFStart = new Date();
        var e = document.createElement('dl'), dls = document.getElementsByTagName('dl');
        sf.id('new').removeAttribute('id'); e.id = 'new'; e.innerHTML = new_res;
        document.body.insertBefore(e,dls[dls.length-1].nextSibling);
        sfevt.recount(e);
    },
    scrollToMessage : function(number) {scrollTo(0,sf.id(number).offsetTop);},
    scrollToNew : function() {scrollTo(0,sf.id('new').offsetTop);},
    countOfID : function(key) {return sevenfour.countOfIDs[key];}
};

/* SF Main events */
var sfevt = {
    onLoad : function(dts,l) {
        var sign = document.createElement('div'), new_dl = sf.id('new'), new_res = new_dl.firstChild;
        sign.id = 'sfnewressign'; sign.innerHTML = 'New Res&thinsp;<span>∷</span>&thinsp;<span>'+new_dl.childNodes.length+'</span>';
        sign.style.display = new_res ? 'block' : 'none'; new_dl.insertBefore(sign,new_res);
        if (! new_res || sign.nextSibling.id != '1') sevenfour.scrollToNew();
        var lr = parseInt(dts[l-1].parentNode.id), bl = sf.id('upperdirectory'), lf = sf.id('loadfactor'), d = location.pathname.match(/.read.cgi.(\w+)/)[1];
        SFForwardRes = ! SFAbbreviated || l == lr || dts[1].parentNode.id == '2' ? 1 : dts[1].parentNode.id;
        if (SFAbbreviated) {
            if (l < lr) {lf.innerText = 'All';}
            else {lf.style.display = 'none'; lf.parentNode.item(3).nodeValue = '';}
        } else {lf.innerText = 'Min';}
        bl.innerText = bl.className = d; bl.href = bl.title = 'http://'+location.hostname+'/'+d+'/';
        sf.id('count').innerText = l; sf.id('range').innerText = lr > 1 ? SFForwardRes+'-'+lr : 1;
        this.checkTheReferrer(lr); sf.loadTimer(); if (! new_res && lr < 1001) sf.attention('NoDelta');
        sf.id('threadtitle').title = document.title;
        SFThreadURI = sf.id('threadtitle').href; SFThreadHasID = sf.element(dts[0],'id') != undefined;
        delete this.onLoad;
    },
    onPopup : function(first_res,l) {
        var e = document.body; e.className = 'popup';
        if (l > 1) {
            var count = document.createElement('div'), same_id = 1; 
            e.className += ' multiplex'; count.id = 'sfpopupheader';
            if (sf.element(first_res,'id')) {
                var es = document.getElementsByTagName('coid'), ID = es[0].cid;
                for (var i = 1; i < l; i++) {
                    var id = es[i].cid; if (id.indexOf('?') != 0 && id == ID) same_id++; else break;
                }
            }
            count.innerText = same_id == l ? 'ID: '+ID+' ∷ '+l+' Res' : l+' Res';
            e.insertBefore(count,e.firstChild);
        }
    },
    recount : function(new_dl) {
        var es = new_dl.getElementsByTagName('coid'), l = es.length;
        var first = new_dl.firstChild, sign = sf.id('sfnewressign');
        sign.parentNode.removeChild(sign); sign.style.display = 'block';
        sign.lastChild.innerText = l; first.parentNode.insertBefore(sign,first);
        sevenfour.scrollToNew();
        var lr = parseInt(new_dl.lastChild.id);
        sf.id('count').innerText = document.getElementsByTagName('dt').length;
        sf.id('range').innerText = SFForwardRes+'-'+lr;
        if (SFThreadHasID) {
            var IDArray = [], Checked = [], i; if (lr > 1000) l -= 1;
            for (i = 0; i < l; i++) {
                var id = es[i].cid; IDArray[i] = id.indexOf('?') != 0 ? id : 'unidentified';
            }
            var IDs = IDArray.toString().replace(/,+/,'');
            for (i = 0; i < l; i++) {
                var id = IDArray[i];
                if (Checked[id]) {
                } else {
                    var str = id.replace(/\W/g,'.'), dID = new RegExp(',?'+str,'g');
                    if (id != 'unidentified') {
                        var ID = new RegExp(',?'+str+',?','g'), coid = sevenfour.countOfIDs[id];
                        var new_count = IDs.match(ID).length;
                        sevenfour.countOfIDs[id] = coid ? coid+new_count : new_count;
                    } else {
                        sevenfour.countOfIDs[id] = '?';
                    }
                    IDs = IDs.replace(dID,''); Checked[id] = 'settled';
                }
            }
            for (i = 0; i < l; i++) {
                var c = sevenfour.countOfIDs[IDArray[i]];
                es[i].innerText = c; es[i].className = c != '?' ? 'c'+c : 'c0';
            }
            delete IDArray; delete Checked;
        }
        this.checkTheReferrer(lr); sf.loadTimer();
        if (sf.id('rangechanger')) sf.rangeChanger(true);
    },
    checkTheReferrer : function(latest) {
        var rs =[], referred = [],  dds = document.getElementsByTagName('dd'), ddsl = dds.length;
        var res_anchor = /^>>?([1-9]\d{0,3})([,-]?)([1-9]\d{0,3})?/, number = /([1-9]\d{0,3})/g;
        var cache = function(rn,referrer) {
            if (sf.id(rn)) {
                if (! rs[rn]) {rs[rn] = []; referred[referred.length] = rn;}
                if (rs[rn][rs[rn].length-1] != referrer) rs[rn][rs[rn].length] = referrer;
            }
        };
        for (var i = SFNextRes; i < ddsl; i++) {
            var as = dds[i].getElementsByTagName('a'), asl = as.length;
            if (! as) {
            } else {
                for (var j = 0; j < asl; j++) {
                    var str = as[j].innerText;
                    if (str.indexOf('>') != 0) {
                    } else {
                        var ra = str.match(res_anchor);
                        if (! ra) {
                        } else {
                            var re = as[j].parentNode.parentNode.id;
                            if (! ra[2]) {
                                cache(ra[1],re);
                            } else if (ra[2] == ',') {
                                var csv = str.match(number), csvl = csv.length;
                                for (var k = 0; k < csvl; k++) cache(csv[k],re);
                            } else if (ra[2] == '-' && ra[3] <= latest) {
                                var first = parseInt(ra[1]), last = parseInt(ra[3]);
                                if (first <= last) for (var m = first; m <= last; m++) cache(m,re);
                            }
                        }
                    }
                }
            }
        }
        for (var i = 0, l = referred.length; i < l; i++) {
            var e = sf.element(referred[i],'cor'), res = rs[referred[i]], nc = res.length;
            var c = parseInt(e.parentNode.className.substr(1));
            e.parentNode.className = c ? 'c'+(c+nc) : 'c'+nc;// e.innerText = c ? c+nc : nc;
            if (! c) e.href = '#'+res; else e.href += ','+res;
        }
        SFNextRes = ddsl; delete rs; delete referred;
    },
    extractionSequence : function(dd) {
        if (dd.className == 'settled') return; else dd.className = 'settled';
        var idre = /ID:[^\w\+\/]?[\w\+\/]{8,9}/g, hasAnchor = dd.getElementsByTagName('a').length > 0;
        if (idre.test(dd.innerText)) {
            var ids = dd.innerText.match(idre), l = ids.length;
            for (var i = 0; i < l; i++) {
                var ot = '<a href="sevenfour://internal/popup'+ids[i].replace(/ID:[^\w\+\/]?/i,'#')+'">';
                dd.innerHTML = dd.innerHTML.split(ids[i]).join(ot+ids[i]+'</a>');
            }
        }
        dd = sf.id(dd.parentNode.id).getElementsByTagName('dd')[0];
        if (hasAnchor && sfv.arrangement(dd)) sfg.sequentialExtraction(dd,0);
    }
};

/* Various search */
var sfi = {
    currentMode : function() {
        var es = document.isearch.elements, l = es.length, i;
        for (i = 0; i <= l; i++) if (es[i].checked) return es[i].id;
    },
    regexp : function(func,str) {
        var RE = str.replace(/(\W)/g,'\\$1');
        switch (func) {
            case 'search':  return new RegExp('.?'+RE,'i'); break;
            case 'highlight':  return new RegExp('.?('+RE+')','i'); break;
        }
    },
    cache : function(empty) {
        var dds = document.getElementsByTagName('dd'), l = dds.length, i;
        if (empty) {
            for (i = 0; i < l; i++) if (dds[i].parentNode.style.display == 'none') return;
            SFISCache = null; delete SFISCache;
        } else {
            SFISCache = []; SFISCache['message'] = []; SFISCache['name'] = [];
            var ns = document.getElementsByTagName('name');
            for (i = 0; i < l; i++) {
                SFISCache['message'][i] = dds[i].innerText.replace(/\n/g,''); SFISCache['name'][i] = ns[i].innerText;
            }
        }
    },
    selectCache: function() {
        switch (this.currentMode()) {
            case 'rsmode': return SFISCache['message']; break;
            case 'nsmode': return SFISCache['name']; break;
        }
    },
    iSearch : function(isquery) {
        switch (this.currentMode()) {
            case 'wsmode': return;
            case 'urimode': return;
            default: if (! isquery) {this.reset(); return;}
        }
        var st = new Date(), c = this.selectCache(), count = 0;
        var dts = document.getElementsByTagName('dt'), l = dts.length;
        isquery = this.regexp('search',isquery);
        if (! document.isearch.pumode.checked) {
            for (var i = 0; i < l; i++) {
                if (! isquery.test(c[i]) || dts[i].parentNode.className.indexOf('residue') != -1) {
                    dts[i].parentNode.style.display = 'none';
                } else {
                    dts[i].parentNode.style.display = 'block'; count++;
                }
            }
            this.rewind(count);
        } else {
            for (var j = 0, resIDs = []; j < l; j++) {
                if (! isquery.test(c[j]) || dts[j].parentNode.className.indexOf('residue') != -1) {}
                else {resIDs[resIDs.length] = dts[j].parentNode.id; count++;}
            }
            sf.id('resultanchor').href = count > 0 ? '#'+resIDs : 'javascript:void(0)';
            sf.id('resultanchor').innerText = count;
            delete resIDs;
        }
        sf.displayTheResult(count,'iSearch',sf.loadTimer(st));
    },
    rewind : function(count_result,first_match,offset) {
        var new_sign = sf.id('sfnewressign');
        if (count_result == document.getElementsByTagName('dt').length) {
            if (new_sign.nextSibling) new_sign.style.display = 'block';
            if (first_match) scrollTo(0,first_match.offsetTop-offset);
            else sevenfour.scrollToNew();
        } else {
            new_sign.style.display = 'none';
            scrollTo(0,0);
        }
    },
    reset : function(highlight) {
        sf.statusMessage('');
        var dds = document.getElementsByTagName('dd'), l = dds.length, none = 0, i;
        for (i = 0; i < l; i++)
            if (dds[i].parentNode.style.display != 'none') {
                var firstMatch = dds[i].parentNode, offset = firstMatch.offsetTop; break;
            }
        for (i = 0; i < l; i++) {
            var e = dds[i].parentNode;
            if (e.style.display != 'none') {}
            else if (e.className.indexOf('residue') == -1) {e.style.display = 'block'; none++;}
        }
        if (none > 0) this.rewind(l,none == l ? false : firstMatch,offset);
        if (highlight && document.getElementsByTagName('em').length > 0) {
            var st = /<\/?EM>/ig;
            for (i = 0; i < l; i++)
                if (dds[i].getElementsByTagName('em').length > 0)
                    dds[i].innerHTML = dds[i].innerHTML.replace(st,'');
        }
        if (document.isearch.pumode.checked) {
            sf.id('resultanchor').href = 'javascript:void(0)'; sf.id('resultanchor').innerText = '0';
        }
        if (SFISCache) this.cache();
    },
    restrictor : function(require) {
        var act = sf.id('sfrestrictor').className;
        var es = document.getElementsByTagName(act), dts = document.getElementsByTagName('dt');
        for (var i = 0, l = es.length, count = 0; i < l; i++) {
            var cox = parseInt(es[i].className.substr(1));
            if (act == 'coid' && require == 1) {
                if (! cox || cox != 1) {dts[i].parentNode.style.display = 'none';}
                else {dts[i].parentNode.style.display = 'block'; count++;}
            } else {
                if (! cox || cox < require) {dts[i].parentNode.style.display = 'none';}
                else {dts[i].parentNode.style.display = 'block'; count++;}
            }
        }
        this.rewind(count);
        sf.statusMessage((act=='cor'?require+' or more replies ∷ ':require==1?'Single ID ∷ ':require+' or more messages ∷ ')+count);
    },
    action : function() {
        var isf = document.isearch.query;
        switch (this.currentMode()) {
            case 'wsmode': this.webSearch('Google'); break;
            case 'urimode': isf.value.indexOf('/read.cgi/') > 0 ?
                location.href = isf.value + '/NEW' : isf.value = ''; isf.blur(); break;
        }
    },
    webSearch : function(search_engine) {
        var fstr = document.isearch.query.value, URI, ps;
        switch (search_engine) {
            case 'Google': ps = 'Google 検索';
                URI = 'http://www.google.com/search?hl=ja&q='; break;
            case 'SearchMash': ps = 'SearchMash 検索';
                URI = 'http://www.searchmash.com/search/'; break;
            case 'Clusty': ps = 'Clusty 検索';
                URI = 'http://clusty.com/search?input-form=clusty-simple&v:sources=webplus&query='; break;
            case 'Translate': ps = 'Google 英日翻訳';
                URI = 'http://translate.google.com/translate_t?langpair=en|ja&hl=ja&ie=UTF8&text='; break;
            case 'Wikipedia': ps = 'Wikipedia 検索';
                URI = 'http://ja.wikipedia.org/w/wiki.phtml?search='; break;
            case 'iTS': ps = 'iTunes Store 検索';
                URI = 'itms://phobos.apple.com/WebObjects/MZSearch.woa/wa/search?term='; break;
            case 'Google:2ch.net': ps = 'Google で 2ch.net 内を検索';
                URI = 'http://www.google.com/search?hl=ja&q=site:2ch.net+'; break;
        }
        var query = getSelection()+'' != '' ? getSelection()+'' : fstr != '' && SFISCache ? fstr : prompt((ps),'');
        if (query) location.replace(encodeURI(URI+query));
    },
    setValue : function(str) {
        var isf = document.isearch.query;
        isf.value = str; setTimeout('document.isearch.query.focus()',50);
        isf.setSelectionRange(isf.value.length,isf.value.length);
    },
    quick : function(str) {
        if (str != '') this.setValue(str);
        setTimeout('sfi.iSearch(document.isearch.query.value)',100);
    },
    modeChange : function(mode) {
        var changeColor = function() {
            sf.id('query').style.color = sf.id('wsmode').checked || sf.id('urimode').checked ? 'black' : sf.id('pumode').checked ? '#12d' : 'black';
        };
        var conversion = function(mode,ph) {
            sf.id(mode).checked = true; sf.id('modecycler').src = SFR+mode+'.png';
            sf.id('query').setAttribute('placeholder',ph);
            changeColor();
        };
        var cycleOption = function(opt) {
            //if (! SFISCache || sf.id('wsmode').checked || sf.id('urimode').checked) return;
            if (sf.id('normode').checked) {
                sf.id('pumode').checked = true;
                sf.id('optioncycler').src = SFR+'puMode.png';
                sf.id('optioncycler').style.background = 'url(sevenfour://skin/SFR/activeRing.png) no-repeat center';
                var a = document.createElement('a'); a.id = 'resultanchor';
                a.href = 'javascript:void(0)'; a.innerText = '0';
                sf.id('isearch').appendChild(a);
            } else {
                sf.id('normode').checked = true;
                sf.id('optioncycler').src = SFR+'optModeInactive.png';
                sf.id('optioncycler').style.background = 'none';
                sf.id('isearch').removeChild(sf.id('resultanchor'));
            }
            changeColor();
        };
        switch (mode ? mode : this.currentMode()) {
            case 'rsmode': conversion('nsmode','名前'); break;
            case 'nsmode': conversion('wsmode','ウェブ'); break;
            case 'wsmode': conversion('urimode','URI'); break;
            case 'urimode': conversion('rsmode','レス'); break;
            case 'cycleopt': cycleOption(); break;
        }
    }
};

/* Video relation */
var sfv = {
    arrangement : function(dd) {
        var as = dd.getElementsByTagName('a'), l = as.length;
        var yt = /http:\/\/(www|jp)\.youtube\.com\/watch.v=([^&]+)/i;
        var gv = /http:\/\/video\.google\.com\/videoplay.docid=([^&]+)/i;
        for (var i = 0; i < l; i++) {
            var URI = as[i].href, ytid = URI.match(yt), gvid = URI.match(gv);
            if (ytid || gvid) {
                var div = document.createElement('div'); div.className = 'vunit';
                div.innerHTML = '<a href="'+URI+'">'+as[i].innerText+'</a> <img class="togglevideo" src="'+SFR+'loadVideo.png" onclick="sfv.switchover(this,\''+(ytid ? ytid[2] : gvid[1])+'\',\''+(ytid ? 'YT' : 'GV')+'\');" ondragstart="return false;" alt="Load/Remove video" />';
                as[i].parentNode.replaceChild(div,as[i]);
            }
        }
        return true;
    },
    switchover : function(btn,vid,vtype) {
        var unit = btn.parentNode;
        if (unit.firstChild.nodeName != 'BLOCKQUOTE') {
            var vc = document.createElement('blockquote'); vc.className = 'moviecontainer';
            var p = document.createElement('p'), obj = document.createElement('object');
            var vsrc = vtype == 'YT' ? 'http://www.youtube.com/v/'+vid : 'http://video.google.com/googleplayer.swf?docId='+vid+'&hl=en';
            with (obj) {
                type = 'application/x-shockwave-flash'; data = vsrc;
                //type = 'video/x-flv'; data = vsrc;
                width = vtype == 'YT' ? '425' : '400'; height = vtype == 'YT' ? '350' : '326';
                innerHTML = '<param name="movie" value="'+vsrc+'" />';
            }
            p.appendChild(obj); vc.appendChild(p); unit.insertBefore(vc,unit.firstChild);
            btn.src = SFR+'remove.png';
            scrollTo(0,unit.firstChild.offsetTop+5);
        } else {
            var yo = pageYOffset-(unit.firstChild.offsetHeight+10);
            unit.removeChild(unit.firstChild);
            btn.src = SFR+'loadVideo.png';
            scrollTo(0,yo);
        }
    }
};

/* Image relation */
var sfg = {
    ICNextRes : 0, ICNextAnchor : 0, ICExecuting : false,
    imgSuffix : function(str) {
        return /^http:.{5,}\.(jpe?g|jp2|png|gif|tiff?|bmp)$/i.test(str);
    },
    load : function(element,URI,index,str,collect) {
        var ic = document.createElement('div');
        ic.className = ! collect ? 'imgcontainer' : this.GalleryImgLength()%2 != 0 ? 'imgcontainer right' : 'imgcontainer left';
        ic.innerHTML = '<img src="'+URI+'" class="loading" onload="sfg.loaded(this.parentNode,'+index+','+collect+');" onerror="sfg.loadFailed(this,'+index+','+collect+');" alt="&emsp;Failed to load&emsp;" /><br />';
        ic.innerHTML += collect ? '<a href="#'+str+'">'+str+'&thinsp;➠&thinsp;</a><span class="imgopener">'+URI+'</span>' : '<a href="'+URI+'" class="extracted"><img src="'+SFR+'imgPopuper.png" alt="Popup" /></a> <span class="imgopener">'+str+'</span>';
        if (collect) sf.id('sfgallery').appendChild(ic);
        else element.parentNode.replaceChild(ic,element);
    },
    loadSS : function(element,URI,index) {
        var ss = document.createElement('span'), br = document.createElement('br');
        ss.innerHTML = '<img src="http://mozshot.nemui.org/shot?'+URI+'" class="sitess" onload="sfg.sequentialExtraction(this.parentNode.parentNode,'+index+');" onclick="sfg.largeSS(\''+URI+'\');" width="128" height="128" alt="" />';
        element.className = 'extracted';
        element.parentNode.insertBefore(ss,element);
        element.parentNode.insertBefore(br,element.nextSibling);
    },
    largeSS : function(URI) {
        var html = '<a href="'+URI+'"><img src="http://mozshot.nemui.org/shot/256x256?'+URI+'" width="256" height="256" alt="" /></a>';
        sfSystem.popupWindow(html,272,272);
    },
    loaded : function(img_parent,index,collect) {
        var img = img_parent.firstChild, pe = img_parent.parentNode;
        if (img.className == 'loading') img.className = 'thumbnail';
        if (img.className == 'thumbnail' && img.nextSibling.className != 'imgtoggle') {
            var e = document.createElement('img'); e.className = 'imgtoggle'; e.src = SFR+'hideImg.png';
            if (pe.nodeName == 'DD') {
                this.centeringBtn(e,img);
                if (sf.id('sfinfobar') && ! sf.id('slideshowstart')) {
                    var ss = document.createElement('li'); ss.id = 'slideshowstart';
                    ss.innerHTML = '<img src="'+SFR+'slideShowBtn.png" onclick="sfg.slideShow(\'Res\');" alt="SS" />';
                    sf.id('complex').insertBefore(ss,sf.id('loadtime'));
                }
            }
            img_parent.insertBefore(e,img_parent.firstChild.nextSibling);// setTimeout('sf.correctRendering()',25);
        }
        if (collect) {
            this.counterUpdate(true); if (this.ICExecuting) this.sequentialExtraction();
        } else {
            this.sequentialExtraction(pe,index);
        }
    },
    loadFailed : function(img,index,collect) {
        img.className = 'loadfailed';
        if (collect) {
            this.counterUpdate(); if (this.ICExecuting) this.sequentialExtraction();
        } else {
            this.sequentialExtraction(img.parentNode.parentNode,index);
        }
    },
    counterUpdate : function(loaded) {
        if (loaded) sf.id('loadedimg').innerText = parseInt(sf.id('loadedimg').innerText)+1;
        else sf.id('failedimg').innerText = parseInt(sf.id('failedimg').innerText)+1;
        if (sf.id('icremainder')) sf.id('icremainder').innerText = parseInt(sf.id('icremainder').innerText)-1;
    },
    collectionStart : function() {
        this.ICExecuting = ! this.ICExecuting;
        var es = document.getElementsByTagName('dd'), l = es.length, sequel = this.ICNextAnchor, ilink = 0;
        for (var i = this.ICNextRes; i < l; i++) {
            var as = es[i].getElementsByTagName('a'), asl = as.length;
            if (! as) {}
            else {for (var j = sequel; j < asl; j++) if (this.imgSuffix(as[j].href)) ilink++;}
            sequel = 0;
        }
        if (ilink > 0) {
            if (! this.ICExecuting) {
                sf.statusMessage('Interrupt',5000);
                setTimeout('if(!sfg.ICExecuting)sf.id("sfnavigator").removeChild(sf.id("icremainder"))',5000);
                return;
            }
            if (! sf.id('icremainder')) {
                var icr = document.createElement('span'); icr.id = 'icremainder'; icr.innerText = ilink;
                sf.id('sfnavigator').insertBefore(icr,sf.id('sfnavigator').firstChild);
            }
            if (! sf.id('sfgallery')) {
                var gallery = document.createElement('div'); gallery.id = 'sfgallery';
                gallery.innerHTML = '<div id="sfgalleryheader" onselectstart="return false;" ondragstart="return false;"><span id="gallerystatus"><span id="ilink">0</span> Image '+(ilink > 1 ? 'links' : 'link')+' - <span id="loadedimg">0</span> Loaded / <span id="failedimg">0</span> Failed</span><span id="gallerycontrol"><img src="'+SFR+'collectImages.png" onclick="sfg.collectionStart(true);" title="Collect Images" alt="Collect Images" /><img src="'+SFR+'slideShowStart.png" onclick="sfg.slideShow(\'Gallery\');" title="Slide show..." alt="Slide show" /><img src="'+SFR+'GalleryClose.png" onclick="sfg.GalleryClose();" title="Gallery Close" alt="Gallery Close" /></span></div>';
                document.body.appendChild(gallery);
                scrollTo(0,sf.id('sfgallery').offsetTop-(innerHeight-70));
            }
            sf.id('ilink').innerText = this.GalleryImgLength()+ilink;
            sf.statusMessage('Collecting images...');
            this.sequentialExtraction();
        } else {
            sf.attention('IC',l-this.ICNextRes); this.ICNextRes = l; this.ICExecuting = false;
            setTimeout('sf.statusMessage("")',3000);
            if (sf.id('icremainder')) setTimeout('sf.id("sfnavigator").removeChild(sf.id("icremainder"))',3000);
        }
    },
    sequentialExtraction : function(res,index) {
        var es = res ? res.getElementsByTagName('a') : document.getElementsByTagName('dd'), l = es.length, i;
        if (! res && ! this.ICExecuting && this.ICNextRes < l) return;
        var exclude = /^(sevenfour:|applewebdata:)|youtube.com.watch.v=|video.google.com.videoplay.docid=|2ch.net.test.read.cgi|\.(zip|gz|sit|dmg|exe|jar|pdf|swf|mp3|mpe?g|avi|wmv)$/i;
        if (res) {
            for (i = index; i < l; i++) {
                if (! es[i].className) {
                    var URI = es[i].href, str = es[i].innerText;
                    if (this.imgSuffix(URI)) {this.load(es[i],URI,i+1,str); break;}
                    else if (! exclude.test(URI)) {this.loadSS(es[i],URI,i+1); break;}
                }
            }
        } else {
            IC: for (i = this.ICNextRes; i < l; i++) {
                var as = es[i].getElementsByTagName('a'), asl = as.length;
                if (! as) {
                } else {
                    for (var j = this.ICNextAnchor; j < asl; j++) {
                        var URI = as[j].href, pe = as[j].parentNode.parentNode; this.ICNextAnchor++;
                        if (this.imgSuffix(URI)) {
                            this.load(as[j],URI,j+1,pe.nodeName=='DIV'?pe.id:pe.parentNode.id,true); break IC;
                        }
                    }
                }
                this.ICNextAnchor = 0;
            }
            if (i == l) {
                sf.statusMessage('Complete',5000);
                this.ICNextRes = l; this.ICExecuting = false;
                sf.id('icremainder').innerText = '0';
                setTimeout('sf.id("sfnavigator").removeChild(sf.id("icremainder"))',5000);
            } else if (this.ICExecuting) {
                sf.statusMessage('Collecting images...');
                this.ICNextRes = i;
            }
        }
    },
    sizeAdjustment : function(img) {
        img.style.visibility = 'hidden';
        img.style.width = 'auto'; img.style.height = 'auto';
        if (sf.id('sfssoverlay')) {
            sf.id('ssimgwidth').innerText = img.width; sf.id('ssimgheight').innerText = img.height;
        }
        if (img.width > innerWidth) {img.style.width = (innerWidth-32)+'px';}
        if (img.height > (innerHeight-44)) {
            img.style.width = 'auto';
            img.style.height = (innerHeight-44)+'px';
        }
        var vertical_position = Math.round((innerHeight-img.height-25)/2);
        var center = Math.floor(img.width/2);
        img.style.marginTop = vertical_position > 10 ? vertical_position+'px' : '10px';
        sf.id('previmgarea').coords = '16,16,'+center+','+(img.height-16);
        sf.id('nextimgarea').coords = (center+1)+',16,'+(img.width-16)+','+(img.height-16);
        img.style.visibility = 'visible';
    },
    slideShow : function(direction) {
        if (! sf.id('sfssoverlay')) {
            SFSSImgs = [];
            var e = direction == 'Res' ? document.body : sf.id('sfgallery');
            var imgs = e.getElementsByTagName('img'), l = imgs.length;
            for (var i = 0; i < l; i++) {
                var permit = (/thumbnail|zoom|actual/.test(imgs[i].className) && imgs[i].style.visibility != 'hidden');
                if (direction == 'Res' && permit) {
                    if (imgs[i].parentNode.parentNode.className.indexOf('settled') == 0) SFSSImgs.push(imgs[i].src);
                } else if (permit) {
                    SFSSImgs.push(imgs[i].src);
                }
            }
            if (SFSSImgs.length == 0) {sf.attention('SlideShow'); delete SFSSImgs; return;}
            document.body.style.overflow = 'hidden';
            SFSSImgs['currentIndex'] = 0;
            var sso = document.createElement('div'), ssimg = document.createElement('img');
            sso.id = 'sfssoverlay'; ssimg.id = 'slideshowimg';
            ssimg.setAttribute('usemap','#ssdirection'); ssimg.alt = 'SFSSImg';
            sso.innerHTML = '<div id="sfssnavi" onselectstart="return false;" ondragstart="return false;"><span id="ssinfo"><span id="sscurrentcount">1</span>/'+SFSSImgs.length+'&emsp;<span id="ssimgwidth">width</span> x <span id="ssimgheight">height</span></span><span id="sscontrol"><img id="previousimg" src="'+SFR+'previous.png" onclick="sfg.slideShow(\'previous\');" alt="prev" /><img id="nextimg" src="'+SFR+'next.png" onclick="sfg.slideShow(\'next\');" alt="next" /><img id="ssclose" src="'+SFR+'slideShowClose.png" onclick="sfg.slideShow(\'close\');" alt="close" /></span></div><map id="ssdirection" name="ssdirection"><area id="previmgarea" href="javascript:sfg.slideShow(\'previous\');" shape="rect" coords="" alt="Previous image" /><area id="nextimgarea" href="javascript:sfg.slideShow(\'next\');" shape="rect" coords="" alt="Next image" /></map>';
            document.body.appendChild(sso);
            sso.insertBefore(ssimg,sso.firstChild);
            ssimg.src = SFSSImgs[0];
            this.sizeAdjustment(ssimg);
            return;
        } else if (direction == 'close') {
            document.body.style.overflow = 'auto';
            document.body.removeChild(sf.id('sfssoverlay'));
            sf.correctRendering();
            delete SFSSImgs;
            return;
        }
        var img = sf.id('slideshowimg'), ssl = SFSSImgs.length, ci = SFSSImgs['currentIndex'];
        if (direction == 'next') {
            img.src = ci+1 == ssl ? SFSSImgs[0] : SFSSImgs[ci+1];
            SFSSImgs['currentIndex'] = ci+1 == ssl ? 0 : ci+1;
            sf.id('sscurrentcount').innerText = ci+1 == ssl ? 1 : ci+2;
        } else {
            img.src = ci == 0 ? SFSSImgs[ssl-1] : SFSSImgs[ci-1];
            SFSSImgs['currentIndex'] = ci == 0 ? ssl-1 : ci-1;
            sf.id('sscurrentcount').innerText = ci == 0 ? ssl : ci;
        }
        this.sizeAdjustment(img);
    },
    adjustGalleryHeader : function() {
        var imgs = sf.id('sfgallery').getElementsByTagName('img'), l = imgs.length, i, max = 0;
        for (i = 0; i < l; i++) if (imgs[i].className == 'actual' && imgs[i].width > max) max = imgs[i].width;
        sf.id('sfgalleryheader').style.width = max+16 > innerWidth ? max+16+'px' : '100%';
    },
    GalleryClose : function() {
        document.body.removeChild(sf.id('sfgallery'));
        this.ICExecuting = false; this.ICNextRes = this.ICNextAnchor = 0; sf.statusMessage('');
        if (sf.id('icremainder')) sf.id('sfnavigator').removeChild(sf.id('icremainder'));
    },
    GalleryImgLength : function() {
        return sf.id('sfgallery') ? sf.id('sfgallery').getElementsByTagName('a').length : 0;
    },
    resize : function(img,ic) {
        if (img.style.visibility == 'hidden' || img.nextSibling.className != 'imgtoggle') return;
        img.className = img.className == 'thumbnail' ? 'zoom' : img.className == 'zoom' ? 'actual' : 'thumbnail';
        if (ic.parentNode.nodeName == 'DD') this.centeringBtn(img.nextSibling,img);
        else ic.style.margin = img.className != 'thumbnail' ? '50px 8px 5px' :
             ic.className.indexOf('right') != -1 ? '50px 0 5px 32%' : '50px 32% 5px 0';
        if (img.className != 'actual') scrollTo(0,img.offsetTop-5);
        else sf.statusMessage('Actual size: '+img.width+' x '+img.height,8000);
        if (ic.parentNode.id == 'sfgallery') this.adjustGalleryHeader();
    },
    toggle : function(btn) {
        var e = btn.parentNode.firstChild, img = e.className == 'reflexunit' ? e.firstChild : e;
        var visible = img.style.visibility != 'hidden';
        img.style.visibility = visible ? 'hidden' : 'visible';
        if (e.className == 'reflexunit') img.nextSibling.style.visibility = visible ? 'hidden' : 'visible';
        btn.src = SFR+(visible ? 'show' : 'hide')+'Img.png';
    },
    display : function(zap) {
        var imgs = document.images, l = imgs.length, vis = zap ? 'hidden' : 'visible';
        var btn_src = SFR+(zap ? 'show' : 'hide')+'Img.png';
        for (var i = 0; i < l; i++) {
            var img = imgs[i];
            if (img.src.indexOf('http:') != 0) {
            } else if (img.className != 'loadfailed') {
                if (zap && (img.className == 'zoom' || img.className == 'actual')) {
                    img.className = 'thumbnail';
                    if (sf.id('sfgallery')) sf.id('sfgalleryheader').style.width = '100%';
                }
                if (img.className != 'thumbnail') {
                    img.style.visibility = vis;
                } else {
                    var ic = img.parentNode; img.style.visibility = vis; img.nextSibling.src = btn_src;
                    if (ic.parentNode.nodeName == 'DD') this.centeringBtn(img.nextSibling,img);
                    else ic.style.margin = ic.className.indexOf('right') != -1 ? '50px 0 5px 32%' : '50px 32% 5px 0';
                }
            }
        }
    },
    centeringBtn : function(btn,img) {
        btn.style.marginLeft = img.width > innerWidth ?
            Math.floor((innerWidth-7)/2)+'px' : Math.floor((img.width-7)/2)+'px';
    }
};

/* Utility */
var sf = {
    id : function(id) {return document.getElementById(id+'');},
    evTarget : function(evt) {return SFIsTiger ? evt : evt.nodeName == '#text' ? evt.parentNode : evt;},
    element : function(element,tag,value) {
        if (typeof(element) != 'object') element = sf.id(element);
        element = element.getElementsByTagName(tag)[0].item(tag != 'id' ? 0 : 1);
        if (! element) return element;
        switch (tag) {
            case 'id': var id = element.innerText.substr(3);
                return value ? id : id != '???' ? element.item(1) : element; break;
            default: return value ? element.innerText : element; break;
        }
    },
    latestRes : function(actual) {
        var dts = document.getElementsByTagName('dt'), l = dts.length-1;
        if (dts[l].parentNode.id > 1000) l -= 1;
        if (actual) return dts[l].parentNode;
        for (var i = l; i >= 0 ; i--) {
            var e = dts[i].parentNode; if (e.style.display != 'none') return e;
        }
        return dts[l].parentNode;
    },
    toggle : function(id) {
        var es = sf.id(id).style;
        if (! es.display) es.display = id == 'sfnavigator' ? 'block' : 'none';
        switch (es.display) {
            case 'none': if (id == 'sfscroller') es.top = Math.round((innerHeight-169)/2)+'px';
                if (id == 'sfrestrictor') es.left = Math.round((innerWidth-169)/2)+'px';
                es.display = 'block'; if (id == 'sfscroller') document.jump.directscroller.focus();
                break;
            case 'block': if (id == 'sfscroller') document.jump.directscroller.blur();
                es.display = 'none';
                break;
        }
        if (id == 'sfnavigator') sf.id('sfheader').style.position = es.display == 'none' ? 'absolute' : 'fixed';
    },
    statusMessage : function(str,timeout) {
        clearTimeout(SFMessageClear);
        sf.id('upperdirectory').style.display = 'none';
        sf.id('status').item(0).innerText = str;
        if (timeout) SFMessageClear = setTimeout('sf.statusMessage("")',timeout);
        if (str == '') sf.id("upperdirectory").style.display = 'inline';
    },
    displayTheResult : function(result,act,time) {
        if (result == 0) {
            this.statusMessage('Not found',7000);
        } else {
            this.statusMessage(time ? result+' Found / '+time : result+' Found',
                act == 'iSearch' && ! sf.id('pumode').checked ? false : 7000);
        }
    },
    attention : function(act,count) {
        if (! sf.id('sfattention')) {
            var div = document.createElement('div'); div.id = 'sfattention';
            div.style.left = Math.round((innerWidth-365)/2)+'px';
            document.body.appendChild(div);
        } else {
            clearTimeout(SFRemoveBezel);
        }
        switch (act) {
            case 'NoDelta': act = 'Loaded ∷ 新しいレスはありません'; break;
            case 'IC': act = 'Image Collect ∷ '+(count==0?'新しいリンクはありません':'画像へのリンクはありません'); break;
            case 'SlideShow': act = 'Slide Show ∷ スライドショー可能な画像はありません'; break;
            case 'AccessDenied': act = 'Access Denied ∷ Please reset the restrictor or search result'; break;
        }
        sf.id('sfattention').innerText = act;
        SFRemoveBezel = setTimeout('document.body.removeChild(sf.id("sfattention"))',5000);
    },
    convertFullwidthToHalfwidth : function(str) {
        return str.replace(/([ａ-ｚＡ-Ｚ０-９＋／])/g,
            function($0){return String.fromCharCode($0.charCodeAt(0)-65248);});
    },
    popupSelectedCharacterLink : function(str) {
        str = this.convertFullwidthToHalfwidth(str);
        var sc = parseInt(str.match(/^[1-9]\d{0,3}$/)) < 1002 ? 'number' : /^[\w\+\/]{8,9}$/.test(str) ? 'id' : '';
        if (sc == 'number' || sc == 'id') {
            var html = '<html><head><title>SelectedCharacterLink</title><style type="text/css">body{margin:0; background:#2553d1; border:2px solid whitesmoke;} p{text-align:center; margin:2px;} a{padding:0 3px; color:ghostwhite; font:normal 9pt "Lucida Grande"; text-decoration:none;}</style></head><body><p>';
            if (sc == 'number') html += '<a href="#'+str+'">&gt;&gt;'+str;
            else if (sc == 'id') html += '<a href="sevenfour://internal/popup#'+str+'">ID:&thinsp;'+str;
            html += '</a></p></body></html>';
            sfSystem.popupWindow(html,128,24);
        }
    },
    rangeChanger : function(update) {
        var rc = sf.id('rangechanger');
        if (rc && ! update) {rc.parentNode.removeChild(rc); return;}
        var l = parseInt(this.latestRes(true).id);
        if (l > 50) {
            if (! rc) {rc = document.createElement('span'); rc.id = 'rangechanger';}
            var str = '<span onclick="sf.switchLoadfactor(';
            rc.innerHTML = ' 最新 ▶'+str+'51)">50</span>';
            for (var i = 100; i < l; i += 100) if (l > i) rc.innerHTML += str+(i+1)+')">'+i+'</span>';
            if (l > document.getElementsByTagName('dt').length && ! SFAbbreviated)
                rc.innerHTML += str+'\'Full\')">All</span>';
            sf.id('loadfactor').parentNode.insertBefore(rc,sf.id('loadfactor'));
        }
    },
    switchLoadfactor : function(lf) {
        location.replace(lf == 'Full' ? SFThreadURI : lf ? SFThreadURI+'l'+lf :
                         SFAbbreviated ? SFThreadURI : SFThreadURI+'/NEW');
    },
    setSnapBackAnchor : function(element) {
        if (document.URL.indexOf('apple') == 0 || element.parentNode.parentNode.id == 1001) return;
        if (element.id) {element.removeAttribute('id');}
        else {if (sf.id('bookmark')) sf.id('bookmark').removeAttribute('id'); element.id = 'bookmark';}
    },
    correctRendering : function() {
        var top = pageYOffset == 0, bottom = pageYOffset == (document.height-innerHeight);
        scrollBy(0,top ? 1 : -1); scrollBy(0,top ? -1 : bottom ? 25 : 1);
    },
    scrollTo : function(str) {
        var dts = document.getElementsByTagName('dt'), l = dts.length;
        var e = /b/i.test(str) ? sf.id('bookmark').parentNode.parentNode :
                /n/i.test(str) ? sf.id('new') :
                /t/i.test(str) ? sf.id('sfheader') :
                /g/i.test(str) ? sf.id('sfgallery') :
                /l(\d{1,3})/i.test(str) ? dts[l-1-parseInt(RegExp.$1)].parentNode :
                /l/i.test(str) ? sf.latestRes() : sf.id(str);
        e.style.display != 'none' ? scrollTo(0,e.offsetTop) : this.scrollTo('n');
    },
    autoScroll : function(speed) {
        clearInterval(SFScrolling);
        switch (speed) {
            case 'slow':
                SFScrolling = setInterval(function() {
                    pageYOffset < (document.height-innerHeight) ? scrollBy(0,1) : sf.autoScroll('stop');
                },100); break;
            case 'fast':
                SFScrolling = setInterval(function() {
                    pageYOffset < (document.height-innerHeight) ? scrollBy(0,1) : sf.autoScroll('stop');
                },50); break;
            default: SFScrolling = 0; break;
        }
    },
    loadTimer : function(stf) {
        var elapsed_time = (new Date().getTime()-(stf ? stf.getTime() : SFStart.getTime()))/1000+' sec.';
        if (stf) {
            return elapsed_time;
        } else {
            this.statusMessage(document.readyState,5000);
            sf.id('loadtime').innerText = elapsed_time; SFStart = 0;
        }
    },
    parseTime : function(res_number) {
        var date_time = sf.element(res_number,'date',true);
        var date = date_time.match(/\d+\/\d+\/\d+/), time = date_time.match(/ \d+:\d+:\d+/);
        date_time = date+time+' GMT+0900';
        if (! SFIsTiger) {
            var ds = date_time.match(/(\d{4}).(\d{2}).(\d{2}) (.+) /);
            var m = ['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'];
            date_time = m[parseInt(ds[2])-1]+' '+ds[3]+' '+ds[1]+' '+ds[4]+' GMT+0900';
        }
        return Date.parse(date_time);
    },
    elapsedTime : function(res_number) {
        var reference = this.parseTime(res_number), current = Date.parse(new Date());
        if (! reference || this.latestRes().id != this.latestRes(true).id) this.attention('AccessDenied');
        var elapsed = new Date((current-reference)-(9*60*60*1000));
        var year = elapsed.getFullYear()-1970, month = elapsed.getMonth(), date = elapsed.getDate()-1;
        var hour = elapsed.getHours(), min = elapsed.getMinutes(), sec = elapsed.getSeconds();
        var str = res_number == 1 ? '最初のレスから ' : '最新のレスから ';
        if (year > 0) str += year+'年 ';
        if (month > 0) str += month+'ヶ月 と ';
        if (date > 0) str += date+'日 と ';
        if (hour > 0) str += hour+'時間 ';
        if (min > 0) str += min+'分 ';
        if (sec > 0) str += sec+'秒 ';
        return str += '経過';
    },
    velocity : function() {
        var nor = parseInt(this.latestRes().id), first = this.parseTime(1), latest = this.parseTime(nor);
        var elapsed = new Date((latest-first)).getTime()/1000/60/60;
        return (nor/elapsed).toString().match(/\d+\D?\d{0,3}/);
    },
    GetInfo : function() {
        if (sf.id('sfinspector')) {document.body.removeChild(sf.id('sfinspector')); return;}
        var ins = document.createElement('div'); ins.id = 'sfinspector';
        ins.style.left = Math.floor((innerWidth-412)/2)+'px';
        ins.innerHTML = '<img class="remove" src="'+SFR+'hideImg.png" alt="remove" /><span>スレッド情報</span><hr /><br />'+document.title+'<br />'+SFThreadURI+'<br /><br /><span>1 つ上の階層 : </span>'+sf.id('upperdirectory').className+'<br /><span>板の URI : </span>'+sf.id('upperdirectory').href+'<br /><br />'+this.elapsedTime(1)+'<br />'+this.elapsedTime(sf.latestRes().id)+'<br /><br /><span>1 時間あたりのレス数 : </span>'+sf.velocity()+'<br /><br /><br /><span>ブラウザ情報</span><hr /><br />SevenFour '+sfSystem.version()+'<br /><br /><span>Platform : </span>'+navigator.platform+'<br /><span>WebKit version : </span>'+navigator.appVersion.match(/AppleWebKit[^ ]+/i)+'<br /><br /><span>Skin : </span>SF Lite Solar Wind v1.1 Preview r070822';
        document.body.appendChild(ins);
    },
    changeTheAppearance : function() {
        sfSystem.setBoardListBGColor(248,248,255); sfSystem.setBoardListFontColor(32,32,32);//GhostWhite
        //PhantomBlack
        //MarinerBlue
        //GroundCherry / Physalis alkekengi
    }
};

/* Event handling */
window.onload = function() {
    var dts = document.getElementsByTagName('dt'), l = dts.length;
    document.URL.indexOf('apple') == 0 ? sfevt.onPopup(dts[0],l):sfevt.onLoad(dts,l);
};
document.onkeydown = function() {
    if (event.metaKey) return;//⌘
    if (event.ctrlKey) {
        switch (event.keyCode) {
            case 65: sf.toggle('sfnavigator'); break;//a
            case 82: sf.toggle('sfrestrictor'); break;//r
            case 74: sf.toggle('sfscroller'); break;//j
            case 78: sevenfour.scrollToNew(); break;//n
            case 66: sf.scrollTo('b'); break;//b
            case 70: sfi.fade(); break;//f
            case 83: sfi.quick(getSelection()+''); break;//s
            case 71: event.shiftKey?sfi.webSearch('SearchMash'):event.altKey?sfi.webSearch('Clusty'):sfi.webSearch('Google'); break;//g
            case 84: sfi.webSearch('Translate'); break;//t
            case 69: sfi.webSearch('Wikipedia'); break;//e
            case 77: sfi.webSearch('iTS'); break;//m
            case 73: sfg.collectionStart(); break;//i
            case 90: sfg.slideShow('previous'); break;//z
            case 88: sfg.slideShow('next'); break;//x
            case 222: sfi.webSearch('Google:2ch.net'); break;//control+shift+2
            default: return;
        }
        event.returnValue = false;
    }
    if (event.altKey) {
        switch (event.keyCode) {
            case 82: sfi.modeChange('urimode'); break;//r
            case 78: sfi.modeChange('rsmode'); break;//n
            case 87: sfi.modeChange('nsmode'); break;//w
            case 85: sfi.modeChange('wsmode'); break;//u
            case 79: sfi.modeChange('cycleopt'); break;//o
            default: return;
        }
        event.returnValue = false;
    }
    var e = document.isearch.query;
    if (event.target == e && e.value && event.keyCode == 13) sfi.iSearch(e.value);//return
};
document.onmousedown = function() {
    SFSelection = getSelection()+'';
    if (sf.evTarget(event.target).id != 'autoscroll') sf.autoScroll('stop');
};
document.onclick = function() {
    var e = sf.evTarget(event.target);
    switch (e.id) {
        case 'sffloat': e.className = e.className != 'lock' ? 'lock':'autohide'; break;
        case 'rangechanger': sf.rangeChanger(); break;
    }
    switch (e.className) {
        case 'imgtoggle': sfg.toggle(e); break;
        case 'imgopener': location.replace(e.parentNode.getElementsByTagName('img')[0].src); break;
        case 'remove': document.body.removeChild(e.parentNode); break;
    }
    switch (e.nodeName) {
        case 'IMG': sfg.resize(e,e.parentNode); break;
        case 'DD': SFSelection != '' ? sf.popupSelectedCharacterLink(SFSelection):sfevt.extractionSequence(e); break;
        case 'SECONDSECTION': sf.setSnapBackAnchor(e);
    }
};
document.oncopy = function() {
    sfi.setValue(getSelection()+'');
};
document.ondragstart = function() {
    if (sf.evTarget(event.target).href == 'javascript:void(0)') return false;
};
/*
document.ondblclick = function() {
    var e = sf.evTarget(event.target);
    if (e.nodeName == 'DD') {
        try {
            alert(SFAbbreviated);
            //alert(e.parentNode.outerHTML);
            //alert(document.body.parentNode.outerHTML);
        } catch(e) {alert('MALFUNCTION\n'+e);}
    }
};*/
